/*
  image processing mini library

  complex_array - allocate a complex array

  adc 11/94

  [Rehack: 3D support (is this really needed ?) and ANSI c by stef 9/2 96]
*/
#include <math.h>
#include <stdio.h>
#include "iplib.h"

/*----------------------------------------------------*/
complex **complex_array(int width, int height)
{
    complex **a;
    int i,j;
    
    if(!(a=(complex **)calloc(height,sizeof(complex *)))) {
	fprintf(stderr,"complex_array: calloc error 1\n");
	exit(0);
    }
    for(i=0; i<height; i++) {
	if(!(a[i]=(complex *)calloc(width,sizeof(complex)))) {
	    fprintf(stderr,"complex_array: calloc error 2\n");
	    exit(0);
	}
    }

    return a;
}

/*--------------------------------------------------------*/
complex ***complex_array3D(int width, int height)
{
    complex ***a;
    int x,y;
    
    if(!(a=(complex ***)calloc(height,sizeof(complex **)))) {
	fprintf(stderr,"[complex_array3D] can't malloc memory (1)\n");
	exit(1);
    }
    for(y=0; y<height; y++) 
	if(!(a[y]=(complex **)calloc(width,sizeof(complex *)))) {
	    fprintf(stderr,"[complex_array3D] can't malloc memory (2)\n");
	    exit(1);
	}
    
    for(y=0; y<height; y++) 
	for(x=0; x<width; x++) 
	    if(!(a[y][x]=(complex *)calloc(3,sizeof(complex)))) {
		fprintf(stderr,"[complex_array3D] can't malloc memory (3)\n");
		exit(1);
	    }

    return a;
}
