/*
  image processing mini library

  col fft used by 2-D fast Fourier transform

  adc 11/94

  [ANSI c by stef 9/2 96]
*/

#include <math.h>
#include <stdio.h>
#include "iplib.h"

void col_fft(complex **a, int n, int rwsz, int inv)
{
    complex t,u,w;
    int i, j, r, ip, nv2, nm1, k, le, le1, m;

    nv2 = n/2;
    nm1 = (n-1);
    j = 0;
    for(i=0; i<nm1; i++) {
	if( i<j ) {
	    for(r=0; r<rwsz; r++) {
		t = a[j][r];
		a[j][r] = a[i][r];
		a[i][r] = t;
	    }
	}
	k = nv2;
	while( k<=j ) {
	    j = j-k;
	    k = k>>1;
	}
	j = j+k;
    }
    m = n;
    le = 1;
    while(m!=1) {
	m = m>>1;
	le1 = le;
	le = le<<1;
	u.re = 1.0;
	u.im = 0.0;
	if(inv==0) {
	    w.re = cos(M_PI/le1);
	    w.im = -sin(M_PI/le1);
	} else {
	    w.re = cos(M_PI/le1);
	    w.im = sin(M_PI/le1);
	}
	for(j=0; j<le1; j++) {
	    for(i=j; i<n; i+=le) {
		ip = i+le1;
		for(r=0; r<rwsz; r++) {
		    t.re = a[ip][r].re*u.re-a[ip][r].im*u.im;
		    t.im = a[ip][r].re*u.im+a[ip][r].im*u.re;
		    a[ip][r].re = a[i][r].re-t.re;
		    a[ip][r].im = a[i][r].im-t.im;
		    a[i][r].re = a[i][r].re+t.re;
		    a[i][r].im = a[i][r].im+t.im;
		}
	    }
	    t.re=u.re*w.re-u.im*w.im;
	    t.im=u.im*w.re+u.re*w.im;
	    u.re=t.re;
	    u.im=t.im;
	    
	}
    }
    if(inv) {
	for(i=0; i<n; i++) {
	    for(j=0; j<rwsz; j++) {
		a[i][j].re = a[i][j].re/n;
		a[i][j].im = a[i][j].im/n;
	    }
	}
    }
}
