/*
  image processing mini library

  float_array - allocate a float array

  adc 11/94

  [Rehack: Colour support and ]
  [ANSI c by stef 9/2 96      ]
*/
#include <math.h>
#include <stdio.h>
#include "iplib.h"

/*--------------------------------------------------------*/
float **float_array(int width, int height)
{
    float **a;
    int i,j;
    
    if(!(a=(float **)calloc(height,sizeof(float *)))) {
	fprintf(stderr,"float_array: calloc error 1\n");
	exit(1);
    }
    for(i=0; i<height; i++) {
	if(!(a[i]=(float *)calloc(width,sizeof(float)))) {
	    fprintf(stderr,"float_array: calloc error 2\n");
	    exit(1);
	}
    }

    return a;
}

/*--------------------------------------------------------*/
float ***float_array3D(int width, int height)
{
    float ***a;
    int x,y;
    
    if(!(a=(float ***)calloc(height,sizeof(float **)))) {
	fprintf(stderr,"[float_array3D] can't malloc memory (1)\n");
	exit(1);
    }
    for(y=0; y<height; y++) 
	if(!(a[y]=(float **)calloc(width,sizeof(float *)))) {
	    fprintf(stderr,"[float_array3D] can't malloc memory (2)\n");
	    exit(1);
	}
    
    for(y=0; y<height; y++) 
	for(x=0; x<width; x++) 
	    if(!(a[y][x]=(float *)calloc(3,sizeof(float)))) {
		fprintf(stderr,"[float_array3D] can't malloc memory (3)\n");
		exit(1);
	    }

    return a;
}


