/*
  image processing mini library

  2-D fast Fourier transform - forward and inverse

  adc 11/94

  [ANSI c by stef 9/2 96]
  [swap width and height in col_fft() (bug) adc 22/2/99]

*/
#include <math.h>
#include <stdio.h>
#include "iplib.h"

complex **fft2d(complex **p, int width, int height, int inv)
{
    complex **a;
    int i,j;
    
    if(!p) return(NULL);
    
    if(!(a=(complex **)calloc(height,sizeof(complex *)))) {
	fprintf(stderr,"fft2d: calloc error 1 %d\n",a);
	exit(0);
    }
    for(i=0; i<height; i++) {
	if(!(a[i]=(complex *)calloc(width,sizeof(complex)))) {
	    fprintf(stderr,"fft2d: calloc error 2\n");
	    exit(0);
	}
    }
    
    for(i=0; i<height; i++) 
	for(j=0; j<width; j++) a[i][j]=p[i][j];
    
    row_fft(a,width,height,inv);
    col_fft(a,height,width,inv);
    
    return a;
}
