/*
  image processing mini library

  free - functions to free memory allocated to arrays

  adc 12/94

  [Rehack: Colour support and ]
  [ANSI c by stef 9/2 96      ]

*/
#include <math.h>
#include <stdio.h>
#include "iplib.h"

/*--------------------------------------------------------*/
void free_uchar_array(unsigned char **p, int height)
{
  int i;
  
  if(!p) {
    fprintf(stderr,"free_uchar_array: NULL pointer\n");
    exit(0);
  }
  for(i=0; i<height; i++) cfree(p[i]);

  cfree(p);

}

/*--------------------------------------------------------*/
void free_uchar_array3D(unsigned char ***p, int height, int width)
{
  int x,y,i;
  
  if(!p) {
      fprintf(stderr,"[free_uchar_array3D] Attempt to free NULL pointer. Bad idea.\n");
      exit(0);
  }
  
  for(x=0;x<width;x++)
      for(y=0;y<height;y++)
	  free(p[y][x]);

  for(y=0;y<height;y++)
      free(p[y]);
  
  free(p);
}

/*--------------------------------------------------------*/
void free_float_array3D(float ***p, int height, int width)
{
  int x,y,i;
  
  if(!p) {
      fprintf(stderr,"[free_uchar_array3D] Attempt to free NULL pointer. Bad idea.\n");
      exit(0);
  }
  
  for(x=0;x<width;x++)
      for(y=0;y<height;y++)
	  free(p[y][x]);

  for(y=0;y<height;y++)
      free(p[y]);
  
  free(p);
}

/*--------------------------------------------------------*/
void free_float_array(float **p, int height)
{
  int i;
  
  if(!p) {
      fprintf(stderr,"free_float_array: NULL pointer\n");
      exit(0);
  }
  for(i=0; i<height; i++) cfree(p[i]);

  cfree(p);

}

/*--------------------------------------------------------*/
void free_complex_array(complex **p, int height)
{
    int i;
  
    if(!p) {
	fprintf(stderr,"free_uchar_array: NULL pointer\n");
	exit(0);
    }
    for(i=0; i<height; i++) cfree(p[i]);

    cfree(p);
}

/*--------------------------------------------------------*/
void free_complex_array3D(complex ***p, int height, int width)
{
  int x,y,i;
  
  if(!p) {
      fprintf(stderr,"[free_uchar_array3D] Attempt to free NULL pointer. Bad idea.\n");
      exit(0);
  }
  
  for(x=0;x<width;x++)
      for(y=0;y<height;y++)
	  free(p[y][x]);

  for(y=0;y<height;y++)
      free(p[y]);
  
  free(p);
}
