/*
  image processing mini library

  normally distributed random variable generator
  zero mean, unit variance
  
  from numerical recipes in C

  adc 10/97
*/
#include <math.h>
#include "iplib.h"

float LARGE_LONG=2147483599;  /* 2^31 - 1 */

float gasdev()
{
  static int iset=0;
  static float gset;
  float fac,r,v1,v2,rn;

  if  (iset == 0) {
    do {
      rn=(float)random()/LARGE_LONG;
      v1=2.0*rn-1.0;
      rn=(float)random()/LARGE_LONG;
      v2=2.0*rn-1.0;
      r=v1*v1+v2*v2;
    } while (r >= 1.0 || r == 0.0);
    fac=sqrt(-2.0*log(r)/r);
    gset=v1*fac;
    iset=1;
    return v2*fac;
  } else {
    iset=0;
    return gset;
  }
}
