/*
  image processing mini library

  row fft used by 2-D fast Fourier transform

  adc 11/94

  [ANSI c by stef 9/2 96]
*/

#include <math.h>
#include <stdio.h>
#include "iplib.h"

void row_fft(complex **a, int n, int clsz, int inv)
{
    complex t,u,w;
    int i, j, r, ip, nv2, nm1, k, le, le1, m;

    nv2 = n/2;
    nm1 = (n-1);
    j = 0;
    for(i=0; i<nm1; i++) {
	if( i<j ) {
	    for(r=0; r<clsz; r++) {
		t = a[r][j];
		a[r][j] = a[r][i];
		a[r][i] = t;
	    }
	}
	k = nv2;
	while( k<=j ) {
	    j = j-k;
	    k = k>>1;
	}
	j = j+k;
    }
  
    m = n;
    le = 1;
    while(m!=1) {
	m = m>>1;
	le1 = le;
	le = le<<1;
	u.re = 1.0;
	u.im = 0.0;
	if(inv==0) {
	    w.re = cos(M_PI/le1);
	    w.im = -sin(M_PI/le1);	
	}
	else {
	    w.re = cos(M_PI/le1);
	    w.im = sin(M_PI/le1);
	}
	for(j=0; j<le1; j++) {
	    for(i=j; i<n; i+=le) {
		ip = i+le1;
		for(r=0; r<clsz; r++) {
		    t.re = a[r][ip].re*u.re-a[r][ip].im*u.im;
		    t.im = a[r][ip].im*u.re+a[r][ip].re*u.im;
		    a[r][ip].re = a[r][i].re-t.re;
		    a[r][ip].im = a[r][i].im-t.im;
		    a[r][i].re = a[r][i].re+t.re;
		    a[r][i].im = a[r][i].im+t.im;
		}
	    }
	    t.re=u.re*w.re-u.im*w.im;
	    t.im=u.im*w.re+u.re*w.im;
	    u.re=t.re;
	    u.im=t.im;
	}
    }
    if(inv) {
	for(i=0; i<clsz; i++) {
	    for(j=0; j<n; j++) {
		a[i][j].re = a[i][j].re/n;
		a[i][j].im = a[i][j].im/n;
	    }
	}
    }
}
