/*
  writepgm.c write out a pgm file

  [Adapted from adc's `writepgm' code by stef 9/2 96]
*/

#include <math.h>
#include <stdio.h>
#include <string.h>

void writeppm(unsigned char ***p, int width, int height, char *filename)
{
    unsigned char *data,*dp;
    int c,i,x,y,datasize,level;
    FILE *fp;

    if(!filename){
	fprintf(stderr,"[writeppm] given filename points to NULL. Bad idea.");
	exit(1);
    }

    if(!(fp=fopen(filename,"w"))) {
	fprintf(stderr,"[writeppm] error opening output file: %s\n",filename);
	exit(1);
    }
  
    fprintf(fp,"P6\n");
    fprintf(fp,"%d %d\n",width,height);
    fprintf(fp,"%d\n",255);
    
    datasize=width*height*3;
    
    if(!(data=(unsigned char *)calloc(sizeof(char),datasize))){
	fprintf(stderr,"[writeppm] can't malloc memory\n");
	exit(1);
    }
    
    dp=data;
    for(y=0;y<height;y++)
	for(x=0;x<width;x++)
	    for(i=0;i<3;i++)
		*dp++=p[y][x][i];
    
    if(!fwrite(data,sizeof(unsigned char),datasize,fp)) {
	fprintf(stderr,"[writeppm] write error: %s\n",filename);
	exit(1);
    }
    
    free(data);

    fclose(fp);
}
	
